FUNCTION GetRegValue(lpKey AS LONG,BYVAL cMainkey AS STRING, BYVAL Key AS STRING) AS STRING
    ON ERROR RESUME NEXT
    DIM RetCode AS LONG
    DIM hKey AS LONG
    DIM KeyNameA AS ASCIIZ * 256
    DIM szdat AS LONG
    DIM cbData AS LONG
    DIM KeyType AS LONG
    DIM acMainKey AS ASCIIZ * 300
    LOCAL zTmp AS ASCIIZ * 256
    LOCAL ZZZ AS STRING
    acMainKey = cMainKey
    RetCode = RegOpenKeyEx(lpKey, acMainkey, 0&, %KEY_ALL_ACCESS, hKey)
        IF RetCode = %ERROR_SUCCESS THEN
            IF Key$ = "*" THEN Key$ = CHR$(0,0)
            szdat=256
            DIM zbuffer AS ASCIIZ*256
            KeyNameA = Key
            cbData = SIZEOF(zTmp)
            RetCode = RegQueryValueEx(BYVAL hKey, KeyNameA, BYVAL 0, KeyType, zTmp, cbData)
            ZZZ = zTmp
            FUNCTION = ZZZ
            EXIT FUNCTION
        END IF
    FUNCTION = ""
END FUNCTION

FUNCTION CachePaths() EXPORT AS LONG
    LOCAL ModulePath AS ASCIIZ * %MAX_PATH
    GetModuleFileName %NULL, ModulePath, SIZEOF(ModulePath)
    SamurizePath = GetRegValue(%HKEY_CURRENT_USER, "Software\Serious Samurize\General\", "DirPath")
    IF LEN(SamurizePath) = 0 THEN SamurizePath = LEFT$(ModulePath, INSTR(-1, ModulePath, "\"))
    TempPath = SamurizePath & "Temp\"
    SkinsBePath = SamurizePath & "SkinsBeLatest\"
END FUNCTION

FUNCTION SaveFile(BYVAL FileName AS STRING,BYVAL FileContent AS STRING) EXPORT AS LONG
    MKDIR TempPath
    SETATTR TempPath, %HIDDEN
    KILL TempPath & FileName
    OPEN TempPath & FileName FOR APPEND AS #1
    PRINT #1, FileContent
    CLOSE #1
END FUNCTION

FUNCTION CacheInfo(BYVAL CacheID AS LONG,BYVAL FileName AS STRING) EXPORT AS LONG
    DIM FileContent AS STRING
    DIM ReadLine AS STRING
    OPEN TempPath & FileName FOR INPUT AS #1
    LINE INPUT #1, SkinsBeCachedTempFile(CacheID)
    WHILE ISFALSE EOF(1)
        LINE INPUT #1, ReadLine
        SkinsBeCachedTempFile(CacheID) = SkinsBeCachedTempFile(CacheID) + ReadLine & $CRLF
    WEND
    CLOSE #1
END FUNCTION

FUNCTION GetHTML(BYVAL URL AS STRING) AS STRING
    DIM oHttp AS WinHttpWinHttpRequest
    SET oHttp = NEW WinHttpWinHttpRequest IN $PROGID_WinHttpWinHttpRequest51
    DIM vMethod AS VARIANT
    DIM vUrl AS VARIANT
    DIM vResponse AS VARIANT
    DIM sResponse AS STRING
    DIM ProxyUsername AS VARIANT
    DIM ProxyPassword AS VARIANT
    DIM ProxyCredentials AS VARIANT
    DIM ProxySetting AS VARIANT

    vMethod          = "GET"
    vUrl             = URL
    ProxyUsername    = GetRegValue(%HKEY_CURRENT_USER, "Software\Serious Samurize\General\", "ProxyUsername")
    ProxyPassword    = GetRegValue(%HKEY_CURRENT_USER, "Software\Serious Samurize\General\", "ProxyPassword")
    ProxyCredentials = "1"
    ProxySetting     = "0"

    OBJECT CALL oHttp.SetProxy(ProxySetting)
    OBJECT CALL oHttp.Open(vMethod, vUrl)
    OBJECT CALL oHttp.SetCredentials(ProxyUsername, ProxyPassword, ProxyCredentials)
    OBJECT CALL oHttp.Send()
    OBJECT GET oHttp.ResponseText TO vResponse
    SET oHttp = NOTHING

    FUNCTION = VARIANT$(vResponse)
END FUNCTION

FUNCTION RemoveFolders(BYREF TargetString AS STRING) AS STRING
    DIM IsNext AS LONG, Start AS LONG
    DIM Find AS LONG
    DIM CutOut AS STRING
    IsNext = 1
    Start = 1
    DO UNTIL IsNext = 0
        Find = INSTR(Start,TargetString,"/")
        TargetString = MID$(TargetString,Find+1)
        IsNext = INSTR(Start,TargetString,"/")
    LOOP
    FUNCTION = TargetString
END FUNCTION

FUNCTION SaveImage(BYVAL Site AS STRING,BYVAL File AS STRING,BYVAL FileName AS STRING) AS LONG
    LOCAL Buffer AS STRING
    LOCAL Entire_page AS STRING, Htmlfile AS STRING, Link AS STRING
    LOCAL Pos AS LONG, Length AS LONG
    DIM WWWREQUEST AS STRING
    DIM strJPEG AS STRING

    TCP OPEN "http" AT Site AS #1 TIMEOUT 15000
        IF ERR THEN
        EXIT FUNCTION
    END IF

    wwwRequest = "GET " + file + " HTTP/1.1" + $CRLF
    wwwRequest = wwwRequest + "Accept: */*" + $CRLF
    wwwRequest = wwwRequest + "Accept-Language: en-us" + $CRLF
    wwwRequest = wwwRequest + "Accept-Encoding: gzip, deflate" + $CRLF
    wwwRequest = wwwRequest + "Host: " + site + $CRLF
    wwwRequest = wwwRequest + "Keep-Alive: 300" + $CRLF
    wwwRequest = wwwRequest + "Connection: Keep-Alive" + $CRLF
    wwwRequest = wwwRequest + "" + $CRLF
    TCP PRINT #1, wwwrequest

    DO
        TCP RECV #1, 4096, Buffer
        Entire_page = Entire_page + Buffer
    LOOP WHILE ISTRUE LEN(buffer) AND ISFALSE ERR

    TCP CLOSE #1

    strJPEG = RIGHT$(Entire_Page,LEN(Entire_Page) - INSTR(1,Entire_Page,CHR$(255))+1)
    Entire_Page = TRIM$(REMOVE$(Entire_Page,strJPEG))

    MKDIR SkinsBePath
    KILL SkinsBePath & FileName
    OPEN SkinsBePath & FileName FOR BINARY AS #2
    PUT$ #2, strJPEG
    CLOSE #2
END FUNCTION

FUNCTION SaveImageAndTempFile(BYREF FileName AS STRING,BYREF Section AS STRING) AS LONG
    DIM HTML AS STRING
    DIM Start AS LONG
    DIM IsNext AS LONG
    DIM TempHeader AS STRING
    DIM TempContent AS STRING
    DIM TempBottom AS STRING
    DIM HostStart AS LONG, HostEnd AS LONG, HostMid AS STRING
    DIM ImageStart AS LONG, ImageEnd AS LONG, ImageMid AS STRING
    DIM ImageName AS STRING
    DIM TempImageMid AS STRING
    DIM A AS STRING
    DIM File AS STRING
    DIM x AS LONG

    DIM WasFileFound AS LONG

    IF Section = "babe" THEN
        HTML = GetHTML("http://www.skins.be")
    ELSE
        HTML = GetHTML("http://www.desktopmachine.com")
    END IF

    Start = INSTR(1,HTML,"<table class='wal'>")-50
    IsNext = 0
    DO UNTIL IsNext = 8
        HostStart = INSTR(INSTR(Start,HTML,"<table class='wal'>") ,HTML,"img src=http://")+LEN("img src=http://")
        HostEnd = INSTR(HostStart,HTML,"/")
        HostMid = MID$(HTML,HostStart,HostEnd-HostStart)

        ImageStart = HostEnd
        ImageEnd = INSTR(ImageStart,HTML," border=")
        ImageMid = MID$(HTML,ImageStart,ImageEnd-ImageStart)

        TempImageMid = ImageMid
        ImageName = RemoveFolders(TempImageMid)

        Start = INSTR(HostEnd,HTML,"</table>")
        IsNext = IsNext + 1
        TempContent = TempContent & "==Image" & FORMAT$(IsNext) & "##" & ImageName & "##" & HostMid & "##" & ImageMid & "##" & $CRLF

        A = DIR$(SkinsBePath & "*.*")
        WasFileFound = 0
        WHILE LEN(A) AND x < 1000
            INCR x
            File = A
            IF File = ImageName THEN
                WasFileFound = 1
                EXIT LOOP
            END IF
            CLOSE #1
            A = DIR$
        WEND
        IF WasFileFound = 0 THEN
            CALL SaveImage(HostMid,ImageMid,ImageName)
        END IF
    LOOP

    TempHeader = "[Data from http://www.skins.be]" & $CRLF
    TempBottom = "[Timer:" & STR$(ROUND(TIMER,0)) & "]"
    TempContent = TempHeader & TempContent & TempBottom
    CALL SaveFile(FileName,TempContent)
END FUNCTION
