#COMPILE DLL
#DIM ALL
#INCLUDE "Win32API.inc"
#INCLUDE "winhttp.inc"

FUNCTION DLLMAIN(BYVAL hInstance AS DWORD, BYVAL Reason AS LONG, BYVAL Reserved AS LONG) AS LONG
    SELECT CASE Reason
        CASE %DLL_PROCESS_ATTACH
            GLOBAL IDNumber AS INTEGER
            GLOBAL SamurizePath AS STRING
            GLOBAL TempPath AS STRING
            GLOBAL SkinsBePath AS STRING
            DIM SkinsBeMeterUpdated(999) AS GLOBAL LONG
            DIM SkinsBeCachedVisning(999) AS GLOBAL STRING
            DIM SkinsBeCachedOutput(999) AS GLOBAL STRING
            DIM SkinsBeCachedTempFile(999) AS GLOBAL STRING
            CALL CachePaths()
            DLLMAIN = 1
            EXIT FUNCTION
    END SELECT
END FUNCTION

#INCLUDE "Skins.be.inc"

FUNCTION init ALIAS "init" EXPORT AS LONG
    DIM func AS STRING
    func = "BabeImage1|BabeImage2|BabeImage3|BabeImage4|BabeImage5|BabeImage6|BabeImage7|BabeImage8|Warning:|Car Images works but are SLOOOOW|CarImage1|CarImage2|CarImage3|CarImage4|CarImage5|CarImage6|CarImage7|CarImage8"
    FUNCTION = STRPTR(func)
END FUNCTION

FUNCTION dlltype ALIAS "dlltype" EXPORT AS LONG
    DIM plugin_type AS INTEGER
    plugin_type = 1
    FUNCTION = plugin_type
END FUNCTION

FUNCTION dllstartup ALIAS "dllstartup" (BYREF hwnd AS DWORD, BYREF plugin_type AS INTEGER) EXPORT AS LONG
    IDNumber = IDNumber + 1
    FUNCTION = IDNumber
END FUNCTION

FUNCTION dllshutdown ALIAS "dllshutdown" (BYVAL id AS INTEGER) EXPORT AS LONG
    FUNCTION = 0
END FUNCTION

FUNCTION getparam ALIAS "getparam" (BYREF func AS ASCIIZ) EXPORT AS LONG
    DIM param AS STRING
    'IF func = "" THEN param = ""
    FUNCTION = STRPTR(param)
END FUNCTION

FUNCTION getinfo ALIAS "getinfo" (BYVAL number AS INTEGER) EXPORT AS LONG
    DIM info AS STRING
    IF number = 0 THEN info = "Skins.be Last Additions"
    IF number = 1 THEN info = "ZanCheZ"
    IF number = 2 THEN info = "1.1"
    IF number = 3 THEN info = "8 Jan 2005"
    IF number = 4 THEN info = "11 Jan 2005"
    IF number = 5 THEN info = "n/a"
    IF number = 6 THEN info = "filt_garn@hotmail.com"
    FUNCTION = STRPTR(info)
END FUNCTION

FUNCTION configure ALIAS "configure" EXPORT AS LONG
    FUNCTION = 0
END FUNCTION

FUNCTION Master(BYREF CacheID AS LONG,BYREF Section AS STRING,BYREF Visning AS STRING) AS STRING
    DIM SecNow AS LONG
    DIM MeterUpdateRate AS LONG
    DIM FileUpdateRate AS LONG
    DIM TempVisning AS STRING
    DIM CreateOutput AS STRING
    DIM FileName AS STRING

    DIM TimerStart AS LONG, TimerEnd AS LONG, TimerMid AS LONG
    DIM CacheTempFileID AS INTEGER

    SecNow = ROUND(TIMER,0)
    MeterUpdateRate = 60
    FileUpdateRate = 900
    IF Section = "babe" THEN
        FileName = "SkinsBeLatestBabes.tmp"
        CacheTempFileID = 1
    ELSE
        FileName = "SkinsBeLatestCars.tmp"
        CacheTempFileID = 2
    END IF
    'CacheID = id
    IF MeterUpdateRate =< SecNow-SkinsBeMeterUpdated(CacheID) OR _
        SecNow < SkinsBeMeterUpdated(CacheID) OR _
        SkinsBeCachedVisning(CacheID) <> Visning THEN

        SkinsBeMeterUpdated(CacheID) = ROUND(TIMER,0)
        SkinsBeCachedVisning(CacheID) = Visning
        TempVisning = RTRIM$(LTRIM$(Visning))
        IF LEN(TempVisning) = 0 THEN
            CreateOutput = "."
        ELSE
            CreateOutput = Visning
        END IF

        IF GETATTR(TempPath & FileName) = 0 THEN CALL SaveImageAndTempFile(FileName,Section)
        IF LEN(SkinsBeCachedTempFile(CacheTempFileID)) = 0 THEN CALL CacheInfo(CacheTempFileID,FileName)

        TimerStart = INSTR(1,SkinsBeCachedTempFile(CacheTempFileID),"[Timer:")+7
        TimerEnd   = INSTR(TimerStart,SkinsBeCachedTempFile(CacheTempFileID),"]")
        TimerMid   = VAL(RTRIM$(LTRIM$(MID$(SkinsBeCachedTempFile(CacheTempFileID), TimerStart, TimerEnd-TimerStart))))

        IF FileUpdateRate =< SecNow-TimerMid OR SecNow < TimerMid THEN
            IF INSTR(1,CreateOutput,"image1") > 0 THEN CALL SaveImageAndTempFile(FileName,Section)
            CALL CacheInfo(CacheTempFileID,FileName)
        END IF

        DIM ImageNameStart AS LONG, ImageNameEnd AS LONG
        DIM Count AS LONG
        DIM ImageName(8) AS STRING
        DIM Start AS LONG
        Start = 1
        FOR Count = 1 TO 8
            ImageNameStart = INSTR(Start,SkinsBeCachedTempFile(CacheTempFileID),"==Image" & FORMAT$(Count) & "##")+10
            ImageNameEnd = INSTR(ImageNameStart,SkinsBeCachedTempFile(CacheTempFileID),"##")
            ImageName(Count) = MID$(SkinsBeCachedTempFile(CacheTempFileID),ImageNameStart,ImageNameEnd-ImageNameStart)
        NEXT

        IF Section = "babe" THEN
            REPLACE "%babeimage1" WITH "" & ImageName(1) & "" IN CreateOutput
            REPLACE "%babeimage2" WITH "" & ImageName(2) & "" IN CreateOutput
            REPLACE "%babeimage3" WITH "" & ImageName(3) & "" IN CreateOutput
            REPLACE "%babeimage4" WITH "" & ImageName(4) & "" IN CreateOutput
            REPLACE "%babeimage5" WITH "" & ImageName(5) & "" IN CreateOutput
            REPLACE "%babeimage6" WITH "" & ImageName(6) & "" IN CreateOutput
            REPLACE "%babeimage7" WITH "" & ImageName(7) & "" IN CreateOutput
            REPLACE "%babeimage8" WITH "" & ImageName(8) & "" IN CreateOutput
            SkinsBeCachedOutput(CacheID) = SkinsBePath & CreateOutput & "%lhttp://www.skins.be"
        ELSE
            REPLACE "%carimage1" WITH "" & ImageName(1) & "" IN CreateOutput
            REPLACE "%carimage2" WITH "" & ImageName(2) & "" IN CreateOutput
            REPLACE "%carimage3" WITH "" & ImageName(3) & "" IN CreateOutput
            REPLACE "%carimage4" WITH "" & ImageName(4) & "" IN CreateOutput
            REPLACE "%carimage5" WITH "" & ImageName(5) & "" IN CreateOutput
            REPLACE "%carimage6" WITH "" & ImageName(6) & "" IN CreateOutput
            REPLACE "%carimage7" WITH "" & ImageName(7) & "" IN CreateOutput
            REPLACE "%carimage8" WITH "" & ImageName(8) & "" IN CreateOutput
            SkinsBeCachedOutput(CacheID) = SkinsBePath & CreateOutput & "%lhttp://www.desktopmachine.com"
        END IF
    END IF
    FUNCTION = SkinsBeCachedOutput(CacheID)
END FUNCTION

FUNCTION BabeImage1 ALIAS "BabeImage1" (BYVAL id AS INTEGER) EXPORT AS LONG
    DIM TempId AS LONG
    DIM OutputString AS STRING
    TempId = id
    OutputString = Master(TempId,"babe","%babeimage1")
    FUNCTION = STRPTR(OutputString)
END FUNCTION

FUNCTION BabeImage2 ALIAS "BabeImage2" (BYVAL id AS INTEGER) EXPORT AS LONG
    DIM TempId AS LONG
    DIM OutputString AS STRING
    TempId = id
    OutputString = Master(TempId,"babe","%babeimage2")
    FUNCTION = STRPTR(OutputString)
END FUNCTION

FUNCTION BabeImage3 ALIAS "BabeImage3" (BYVAL id AS INTEGER) EXPORT AS LONG
    DIM TempId AS LONG
    DIM OutputString AS STRING
    TempId = id
    OutputString = Master(TempId,"babe","%babeimage3")
    FUNCTION = STRPTR(OutputString)
END FUNCTION

FUNCTION BabeImage4 ALIAS "BabeImage4" (BYVAL id AS INTEGER) EXPORT AS LONG
    DIM TempId AS LONG
    DIM OutputString AS STRING
    TempId = id
    OutputString = Master(TempId,"babe","%babeimage4")
    FUNCTION = STRPTR(OutputString)
END FUNCTION

FUNCTION BabeImage5 ALIAS "BabeImage5" (BYVAL id AS INTEGER) EXPORT AS LONG
    DIM TempId AS LONG
    DIM OutputString AS STRING
    TempId = id
    OutputString = Master(TempId,"babe","%babeimage5")
    FUNCTION = STRPTR(OutputString)
END FUNCTION

FUNCTION BabeImage6 ALIAS "BabeImage6" (BYVAL id AS INTEGER) EXPORT AS LONG
    DIM TempId AS LONG
    DIM OutputString AS STRING
    TempId = id
    OutputString = Master(TempId,"babe","%babeimage6")
    FUNCTION = STRPTR(OutputString)
END FUNCTION

FUNCTION BabeImage7 ALIAS "BabeImage7" (BYVAL id AS INTEGER) EXPORT AS LONG
    DIM TempId AS LONG
    DIM OutputString AS STRING
    TempId = id
    OutputString = Master(TempId,"babe","%babeimage7")
    FUNCTION = STRPTR(OutputString)
END FUNCTION

FUNCTION BabeImage8 ALIAS "BabeImage8" (BYVAL id AS INTEGER) EXPORT AS LONG
    DIM TempId AS LONG
    DIM OutputString AS STRING
    TempId = id
    OutputString = Master(TempId,"babe","%babeimage8")
    FUNCTION = STRPTR(OutputString)
END FUNCTION

FUNCTION CarImage1 ALIAS "CarImage1" (BYVAL id AS INTEGER) EXPORT AS LONG
    DIM TempId AS LONG
    DIM OutputString AS STRING
    TempId = id
    OutputString = Master(TempId,"car","%carimage1")
    FUNCTION = STRPTR(OutputString)
END FUNCTION

FUNCTION CarImage2 ALIAS "CarImage2" (BYVAL id AS INTEGER) EXPORT AS LONG
    DIM TempId AS LONG
    DIM OutputString AS STRING
    TempId = id
    OutputString = Master(TempId,"car","%carimage2")
    FUNCTION = STRPTR(OutputString)
END FUNCTION

FUNCTION CarImage3 ALIAS "CarImage3" (BYVAL id AS INTEGER) EXPORT AS LONG
    DIM TempId AS LONG
    DIM OutputString AS STRING
    TempId = id
    OutputString = Master(TempId,"car","%carimage3")
    FUNCTION = STRPTR(OutputString)
END FUNCTION

FUNCTION CarImage4 ALIAS "CarImage4" (BYVAL id AS INTEGER) EXPORT AS LONG
    DIM TempId AS LONG
    DIM OutputString AS STRING
    TempId = id
    OutputString = Master(TempId,"car","%carimage4")
    FUNCTION = STRPTR(OutputString)
END FUNCTION

FUNCTION CarImage5 ALIAS "CarImage5" (BYVAL id AS INTEGER) EXPORT AS LONG
    DIM TempId AS LONG
    DIM OutputString AS STRING
    TempId = id
    OutputString = Master(TempId,"car","%carimage5")
    FUNCTION = STRPTR(OutputString)
END FUNCTION

FUNCTION CarImage6 ALIAS "CarImage6" (BYVAL id AS INTEGER) EXPORT AS LONG
    DIM TempId AS LONG
    DIM OutputString AS STRING
    TempId = id
    OutputString = Master(TempId,"car","%carimage6")
    FUNCTION = STRPTR(OutputString)
END FUNCTION

FUNCTION CarImage7 ALIAS "CarImage7" (BYVAL id AS INTEGER) EXPORT AS LONG
    DIM TempId AS LONG
    DIM OutputString AS STRING
    TempId = id
    OutputString = Master(TempId,"car","%carimage7")
    FUNCTION = STRPTR(OutputString)
END FUNCTION

FUNCTION CarImage8 ALIAS "CarImage8" (BYVAL id AS INTEGER) EXPORT AS LONG
    DIM TempId AS LONG
    DIM OutputString AS STRING
    TempId = id
    OutputString = Master(TempId,"car","%carimage8")
    FUNCTION = STRPTR(OutputString)
END FUNCTION
